<?php

require_once("vendor/flexi/flexi.php");
require_once("lib/visual.inc.php");
require_once("lib/classes/UserManagement.class.php");

class Wikifarmuebersicht extends StudIPPlugin implements AdministrationPlugin {

    function __construct()
    {
		if ($GLOBALS['perm']->have_perm("root")) {
            Navigation::addItem('/admin/tools/wikifarmuebersicht', new Navigation($this->getPluginName(), PluginEngine::getUrl($this)));
        }
    }

    function show_action()
    {
		$GLOBALS['perm']->check("root");
		Navigation::activateItem('/admin/tools/wikifarmuebersicht');

		$factory = new Flexi_TemplateFactory(dirname(__FILE__)."/templates");
		$template = $factory->open("index");

		$farms = $this->_findFarms();	
		if(sizeof($farms) > 0)
		{
		    $wfid = $_REQUEST['wfid'];    
		    $farmid = $wfid != "" ? $wfid : $farms[0]['id'];
		    
		    $template->set_attribute('farmCurrent', $farmid);
		    $template->set_attribute('farmsAll', $farms);   
		    $template->set_attribute('seminarsAll', $this->_findAllSeminars($farmid));
		    $template->set_attribute('institutesAll', $this->_findAllInstitutes($farmid));
		}	
		
		$template->set_layout('layout.php');
		$template->set_attribute('plugin', $this);
        
		echo $template->render();
    }

	function getPluginname(){
		return _("Wikifarm-bersicht");
	}

	function _findAllSeminars($farmid){

		$sql = "SELECT oc.*, s.Seminar_id, s.Name, s.Untertitel FROM object_contentmodules oc JOIN seminare s ON (oc.object_id = s.Seminar_id) WHERE oc.system_type = '$farmid' AND oc.module_type = 'wiki' ORDER BY oc.module_id, s.Name ASC";
		$result = $this->_sqlQuery($sql);
		
		return $result;
	}
	
	function _findAllInstitutes($farmid){

		$sql = "SELECT oc.*, i.Institut_id, i.Name, i.fakultaets_id FROM object_contentmodules oc JOIN Institute i ON (oc.object_id = i.Institut_id) WHERE oc.system_type = '$farmid' AND oc.module_type = 'wiki' ORDER BY oc.module_id, i.Name ASC";
		$result = $this->_sqlQuery($sql);
		
		return $result;
	}

	function _sqlQuery($sql){

		if(trim($sql) == "")
			return null;
		else
		{
			$db = DBManager::get();			
			return $db->query($sql);
		}
	}
	
	function _findFarms(){
	
	    global $ELEARNING_INTERFACE_MODULES;
	    $farms = array();
	    
	    if(is_array($ELEARNING_INTERFACE_MODULES))
	    {   
		$eims = array_keys($ELEARNING_INTERFACE_MODULES);

		for($i=0; $i<sizeof($eims); $i++)
		{
		    $ck = "$eims[$i]";
		    if($ELEARNING_INTERFACE_MODULES[$ck]['CLASS_PREFIX'] == "PmWiki")
		    {
			$data = array(
			    "id" => $ck, 
			    "name" => $ELEARNING_INTERFACE_MODULES[$ck]['name'],
			    "path" => $ELEARNING_INTERFACE_MODULES[$ck]['ABSOLUTE_PATH_SOAP'] 
			);
			array_push($farms, $data);
		    }
		}  
	    }	 
	    return $farms;
	}
}

		
